#!c:\Python2.4\python.exe
try:
    import os, sys, time
    import imdb
    import pickle
    from sqlobject import *
    from math import ceil
    import psyco
    psyco.full()    
except ImportError:
    print 'You need to install the IMDbPY package!'
    sys.exit(1)

CTIME = int(time.time())
BEGIN_TIME = CTIME

in_encoding = sys.stdin.encoding or sys.getdefaultencoding()
out_encoding = sys.stdout.encoding or sys.getdefaultencoding()

class Movies(SQLObject):
    title = StringCol()
    year = IntCol()

print "Connecting to SQL DB's"
i = imdb.IMDb('sql', uri='mysql://root:pass@localhost/imdb')
sqlhub.processConnection = connectionForURI('mysql://root:pass@localhost/netflix')

print "Loading feature maps"
gID = open('people-25-occurences.pickle', 'r')
peopleIDs = pickle.load(gID)
gID.close()

gID = open('country.pickle', 'r')
countryID = pickle.load(gID)
gID.close()

countryIDs = {}
for c in countryID:
    countryIDs[str(c)] = len(peopleIDs) + len(countryIDs) + 1

gID = open('genre.pickle', 'r')
genreID = pickle.load(gID)
gID.close()

genreIDs = {}
for g in genreID:
    genreIDs[str(g)] = len(peopleIDs) + len(countryIDs) + len(genreIDs) + 1

totalFeatures = len(peopleIDs) + len(countryIDs) + len(genreIDs) + 11

print "\t" + str(len(peopleIDs)) + " people, "+ str(len(countryIDs))+" countries, "+str(len(genreIDs))+" genres"
print "\t" + str(totalFeatures)+ " total."

print "\nBuilding movie feature vectors..."

missing = 0
count = 0
cellCount = 0
movieHash = {}

def save():
    print str(count)+" movies processed. Saving map..."
    print str(len(movieHash))

    pID  = open('movie-map-25.pickle', 'w')
    pickle.dump(movieHash, pID)
    pID.close()  
        
    print 'Saved. (in %d minutes, %d seconds)' % divmod(int(time.time())-BEGIN_TIME, 60)
    print "Cellcount: "+str(cellCount)+", "+str((float(cellCount)/float(totalFeatures*count))*100)+" percent full \n"
    return 

def yearFID(year):
    return int(ceil((year-1900)/10))+1

for movie in Movies.select():
    title = unicode(movie.title, in_encoding, 'replace')
    fVector = []
    movieUID = movie.id
    movieYEAR = movie.year
    #print movie.title + ", id: " + str(movie.id) + ", year: "+ str(movie.year)
    if count % 50 == 0: print str(count)
    
    try:
        results = i.search_movie(title)
        count += 1
        
        # Year
        if movieYEAR != None:
            fVector.append(totalFeatures-11+yearFID(movieYEAR))
        
        if not results:
            missing += 1
            print "Missing: " + title            
        else:
            movie = results[0]
            i.update(movie)
            
            director = movie.get('director')
            writer = movie.get('writer')
            producer = movie.get('producer')
            composer = movie.get('composer')
            cast = movie.get('cast')
            country = movie.get('country', u'')
            genres = movie.get('genres')
            
            # Get rid of the duplicates
            involved = set()
            if director != None: involved.update(director)
            if writer != None: involved.update(writer)
            if producer != None: involved.update(producer)
            if composer != None: involved.update(composer)
            if cast != None: involved.update(cast)
            
            if len(involved) > 0:
                for p in involved:
                    if str(p) in peopleIDs:
                        fVector.append(peopleIDs[str(p)])
      
            # Countries
            if country != None:
                for c in country:
                    if c in countryIDs: fVector.append(countryIDs[str(c)])
                    
            # Genres - Write ...
            if genres != None:
                for g in genres:
                    if str(g) in genreIDs: fVector.append(genreIDs[str(g)])
                    else: print "genre not found..??"
            
            fVector.sort()
        
        movieHash[movieUID] = fVector
        cellCount = cellCount + len(fVector)
                
    except imdb.IMDbError, e:
        print "Error report:"
        print e
        continue
    
    if count % 500 == 0: save()
    
print "\n ---- Done ---- \n"
print "Movies: "+str(count)+", Missing: "+str(missing)+"\n"

print "Saving maps..."
save()

print 'Hoorah!'
