#!c:\Python2.4\python.exe
try:
    import os, sys, time
    import imdb
    import pickle
    from sqlobject import *
except ImportError:
    print 'You need to install the IMDbPY package!'
    sys.exit(1)

CTIME = int(time.time())
BEGIN_TIME = CTIME

in_encoding = sys.stdin.encoding or sys.getdefaultencoding()
out_encoding = sys.stdout.encoding or sys.getdefaultencoding()

class Movies(SQLObject):
    title = StringCol()

i = imdb.IMDb('sql', uri='mysql://root:pass@localhost/imdb')
sqlhub.processConnection = connectionForURI('mysql://root:pass@localhost/netflix')

missing = 0
overlap = 0
print "Processing movies."

count = 0
people = {}
genre = []
countries = []
specEffects = []
visEffects = []

for movie in Movies.select():
    title = unicode(movie.title, in_encoding, 'replace')
    if count % 50 == 0: print str(count)
    
    try:
        results = i.search_movie(title)
        if not results:
            missing += 1
            count += 1
            
            print "Missing: " + title
            
        else:
            count += 1    
            movie = results[0]
            i.update(movie)
            
            director = movie.get('director')
            writer = movie.get('writer')
            producer = movie.get('producer')
            composer = movie.get('composer')
            cast = movie.get('cast')
            country = movie.get('country', u'')
            genres = movie.get('genres')
            rating = movie.get('rating')
            votes = movie.get('votes')
            
            # Get rid of the duplicates
            involved = set()
            if director != None: involved.update(director)
            if writer != None: involved.update(writer)
            if producer != None: involved.update(producer)
            if composer != None: involved.update(composer)
            if cast != None: involved.update(cast)
            
            if len(involved) > 0:
                for p in involved:
                    if str(p) not in people: people[str(p)] = [len(people)+1, 1]
                    else:
                        people[str(p)] = [people[str(p)][0], people[str(p)][1]+1]
                        overlap = overlap+1           
            
            if rating == None: rating = 0
            if votes == None: votes = 0
                   
            # Genres - Write ...
            if genres != None:
                for g in genres:
                    if g not in genre: genre.append(g)
                        
            # Countries
            if country != None:
                for c in country:
                    if c not in countries: countries.append(c)
        
    except imdb.IMDbError, e:
        print "Error report:"
        print e
        continue
        #sys.exit(3)
    
    if count % 500 == 0:
        print str(count)+" movies processed. Saving maps..."

        # People
        print "\t People: " + str(len(people))          
        pID = open('people.pickle', 'w')
        pickle.dump(people, pID)
        pID.close()  
        
        # Genres
        print "\t Genres: " + str(len(genre))
        gID = open('genre.pickle', 'w')
        pickle.dump(genre, gID)
        gID.close()
        
        # Countries
        print "\t Countries: " + str(len(countries))
        cID = open('country.pickle', 'w')
        pickle.dump(countries, cID)
        cID.close()
        
        print 'Saved. (in %d minutes, %d seconds)' % \
            divmod(int(time.time())-BEGIN_TIME, 60)
        print 'Overlap: %d / %d ... %d' % (overlap, len(people), overlap/len(people))
    #if count == 25: break
    
print "\n ---- Done ---- \n"
print "Movies: "+str(count)+", Missing: "+str(missing)+"\n"
print 'Overlap: %d / %d ... %d\n' % (overlap, len(people), overlap/len(people))

print "Saving maps..."

# People
print "\t People: " + str(len(people))    
pID = open('people.pickle', 'w')
pickle.dump(people, pID)
pID.close()  

# Genres
print "\t Genres: " + str(len(genre))
gID = open('genre.pickle', 'w')
pickle.dump(genre, gID)
gID.close()

# Countries
cID = open('country.pickle', 'w')
pickle.dump(countries, cID)
cID.close()

print 'Hoorah! (%d minutes, %d seconds)' % \
            divmod(int(time.time())-BEGIN_TIME, 60)